package com.hfkj.dao;

import com.hfkj.entity.BsBankActivityRosterRate;
import com.hfkj.entity.BsBankActivityRosterRateExample.Criteria;
import com.hfkj.entity.BsBankActivityRosterRateExample.Criterion;
import com.hfkj.entity.BsBankActivityRosterRateExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsBankActivityRosterRateSqlProvider {

    public String countByExample(BsBankActivityRosterRateExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_bank_activity_roster_rate");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsBankActivityRosterRateExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_bank_activity_roster_rate");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsBankActivityRosterRate record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_bank_activity_roster_rate");
        
        if (record.getBankActivityId() != null) {
            sql.VALUES("bank_activity_id", "#{bankActivityId,jdbcType=BIGINT}");
        }
        
        if (record.getBankActivityRosterId() != null) {
            sql.VALUES("bank_activity_roster_id", "#{bankActivityRosterId,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.VALUES("platform_no", "#{platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.VALUES("cup_no", "#{cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getWelfareRatesId() != null) {
            sql.VALUES("welfare_rates_id", "#{welfareRatesId,jdbcType=BIGINT}");
        }
        
        if (record.getPreferentialModel() != null) {
            sql.VALUES("preferential_model", "#{preferentialModel,jdbcType=INTEGER}");
        }
        
        if (record.getStartTime() != null) {
            sql.VALUES("start_time", "#{startTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getEndTime() != null) {
            sql.VALUES("end_time", "#{endTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRates() != null) {
            sql.VALUES("rates", "#{rates,jdbcType=VARCHAR}");
        }
        
        if (record.getPreferentialRates() != null) {
            sql.VALUES("preferential_rates", "#{preferentialRates,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsBankActivityRosterRateExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("bank_activity_id");
        sql.SELECT("bank_activity_roster_id");
        sql.SELECT("mer_id");
        sql.SELECT("platform_no");
        sql.SELECT("cup_no");
        sql.SELECT("welfare_rates_id");
        sql.SELECT("preferential_model");
        sql.SELECT("start_time");
        sql.SELECT("end_time");
        sql.SELECT("rates");
        sql.SELECT("preferential_rates");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_bank_activity_roster_rate");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsBankActivityRosterRate record = (BsBankActivityRosterRate) parameter.get("record");
        BsBankActivityRosterRateExample example = (BsBankActivityRosterRateExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_bank_activity_roster_rate");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getBankActivityId() != null) {
            sql.SET("bank_activity_id = #{record.bankActivityId,jdbcType=BIGINT}");
        }
        
        if (record.getBankActivityRosterId() != null) {
            sql.SET("bank_activity_roster_id = #{record.bankActivityRosterId,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.SET("platform_no = #{record.platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.SET("cup_no = #{record.cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getWelfareRatesId() != null) {
            sql.SET("welfare_rates_id = #{record.welfareRatesId,jdbcType=BIGINT}");
        }
        
        if (record.getPreferentialModel() != null) {
            sql.SET("preferential_model = #{record.preferentialModel,jdbcType=INTEGER}");
        }
        
        if (record.getStartTime() != null) {
            sql.SET("start_time = #{record.startTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getEndTime() != null) {
            sql.SET("end_time = #{record.endTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRates() != null) {
            sql.SET("rates = #{record.rates,jdbcType=VARCHAR}");
        }
        
        if (record.getPreferentialRates() != null) {
            sql.SET("preferential_rates = #{record.preferentialRates,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_bank_activity_roster_rate");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("bank_activity_id = #{record.bankActivityId,jdbcType=BIGINT}");
        sql.SET("bank_activity_roster_id = #{record.bankActivityRosterId,jdbcType=BIGINT}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("platform_no = #{record.platformNo,jdbcType=VARCHAR}");
        sql.SET("cup_no = #{record.cupNo,jdbcType=VARCHAR}");
        sql.SET("welfare_rates_id = #{record.welfareRatesId,jdbcType=BIGINT}");
        sql.SET("preferential_model = #{record.preferentialModel,jdbcType=INTEGER}");
        sql.SET("start_time = #{record.startTime,jdbcType=TIMESTAMP}");
        sql.SET("end_time = #{record.endTime,jdbcType=TIMESTAMP}");
        sql.SET("rates = #{record.rates,jdbcType=VARCHAR}");
        sql.SET("preferential_rates = #{record.preferentialRates,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsBankActivityRosterRateExample example = (BsBankActivityRosterRateExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsBankActivityRosterRate record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_bank_activity_roster_rate");
        
        if (record.getBankActivityId() != null) {
            sql.SET("bank_activity_id = #{bankActivityId,jdbcType=BIGINT}");
        }
        
        if (record.getBankActivityRosterId() != null) {
            sql.SET("bank_activity_roster_id = #{bankActivityRosterId,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.SET("platform_no = #{platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.SET("cup_no = #{cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getWelfareRatesId() != null) {
            sql.SET("welfare_rates_id = #{welfareRatesId,jdbcType=BIGINT}");
        }
        
        if (record.getPreferentialModel() != null) {
            sql.SET("preferential_model = #{preferentialModel,jdbcType=INTEGER}");
        }
        
        if (record.getStartTime() != null) {
            sql.SET("start_time = #{startTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getEndTime() != null) {
            sql.SET("end_time = #{endTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRates() != null) {
            sql.SET("rates = #{rates,jdbcType=VARCHAR}");
        }
        
        if (record.getPreferentialRates() != null) {
            sql.SET("preferential_rates = #{preferentialRates,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsBankActivityRosterRateExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}